#ifndef LOAN_H
#define LOAN_H

#include <FL/Fl_Check_Button.H>
#include "Borrower.h"
#include "Lender.h"
#include "Selection.h"
#include <stdio.h>

class Loan : public Fl_Check_Button {
 
 public:
  float originalValue;
  float principalRemaining;
  float discountRate;
  float interestRate;
  bool isARM;
  char* settlementDate;
  int term;
  int risk;
  Borrower* borrower;
  Lender* lender;
  bool isJumbo;
  double propertyID;
  char* buttonlabel;
 

  static Loan* displayLoans( Selection* );


  Loan *prev;
  Loan *next;
  Loan(float a,float b,bool c,char* d,int e,bool h,Loan* previous) : Fl_Check_Button(15,65,380,50," "){  
    originalValue=a;
    interestRate=b;
    principalRemaining = a;
    discountRate=a/2.0;
    isARM=c;
    settlementDate=d;
    term=e;
    risk=5;
    //   borrower=f;
    //   lender=g;
    isJumbo=h;
    //    propertyID=i;
    prev = previous;
    next = NULL;
    buttonlabel = new char[500];
    char irtype[4];
    if(c) strcpy( irtype, "FM" );
    else  strcpy(irtype, "ARM");
    char loansize[8];
    if(h) strcpy( loansize, "Regular" );
    else  strcpy( loansize, "Jumbo" );
    sprintf(buttonlabel,"Value:$%.2f    IR:%.3f   IRType:%s\nSettlement Date:%s   Size:%s\nTerm:%i ",a,b,irtype,d,loansize,e);

    label(buttonlabel);
  };
  Loan() : Fl_Check_Button(0,0,380,50,"") { next = NULL;};

};
#endif
